#include "stm32f4_discovery.h"
#include "stm32f4xx_conf.h" // again, added because ST didn't put it here ?
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "stm32f4xx_spi.h"
#include "usart.h"
#include "delay.h"

//PI2 AF5 - piny  SCK=PB10, miso=pc2, mosi=pc3, cs=pb12
void initSpi(void) {
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

    GPIO_InitTypeDef GPIO_InitStruct;
    GPIO_StructInit(&GPIO_InitStruct);
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3;
    GPIO_Init(GPIOC, &GPIO_InitStruct);
	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_10;
    GPIO_Init(GPIOB, &GPIO_InitStruct);
GPIO_InitStruct.GPIO_Pin = GPIO_Pin_12;
GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT;
GPIO_Init(GPIOB, &GPIO_InitStruct);

    GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_SPI2);
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource2, GPIO_AF_SPI2);
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource3, GPIO_AF_SPI2);


    SPI_InitTypeDef SPI_InitStructure;
    SPI_I2S_DeInit(SPI2);
    SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
    SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
    SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; //set speed here
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
    SPI_Init(SPI2, &SPI_InitStructure);

    SPI_Cmd(SPI2, ENABLE);
//	SPI_SSOutputCmd(SPI2,ENABLE);
}

u8 spi_GetByte() {
//@@@ use chipselect before and after reading a buffer too
    u32 LIS302DLTimeout = 0x1000;
    /* Wait to receive a Byte */
    while (SPI_I2S_GetFlagStatus(SPI2,  SPI_FLAG_RXNE) == RESET) {
        if((LIS302DLTimeout--) == 0) return 0x00;
    }

    /* Return the Byte read from the SPI bus */
    uint8_t r= (u8)SPI_I2S_ReceiveData(SPI2);
return r;
}


void spi_SendByte(u8 byte) {
    u32 LIS302DLTimeout = 0x1000;

    while (SPI_I2S_GetFlagStatus(SPI2, SPI_FLAG_TXE) == RESET) {
        if((LIS302DLTimeout--) == 0) return;
    }

    /* Send a Byte through the SPI peripheral */
    SPI_I2S_SendData(SPI2, byte);
}

void spi_write(uint8_t *msg, uint8_t len)
{
GPIO_ResetBits(GPIOB, GPIO_Pin_12);
while(len--) spi_SendByte(*msg++);
//wait for transmission complete
FlagStatus s;
do {
	s= SPI_I2S_GetFlagStatus(SPI2,SPI_I2S_FLAG_BSY);
	}while(s==SET);
GPIO_SetBits(GPIOB, GPIO_Pin_12);
}



int main(void)
{
usart2_init(115200);
inuart2line=inuart2len=0;


RCC_ClocksTypeDef RCC_ClocksStatus;

print(USART2, "\nspi testik\n"); 
initSpi();
print(USART2, "init done\n"); 

uint8_t msg1[3] = {0x40,0x01,0xfe};
uint8_t msg2[3] = {0x40,0x13,0x1};
uint8_t msg3[3] = {0x40,0x13,0x0};

        spi_write(msg1,3);
	delay_ms(1000);

while (1)
  {
  print(USART2, "toggle bit\n");
  	spi_write(msg2,3);
        delay_ms(500);
	spi_write(msg3,3);
        delay_ms(500);
    
  }
}


